static int stats_checkhand (char *oldnick, char *newnick)
{
  globstats *gs;
  locstats *ls;
  int found = 0;
  
  Context;
  for (gs = sdata; gs; gs = gs->next) {
    for (ls = gs->local; ls; ls = ls->next) {
      if (!strcmp(oldnick, ls->user) && strcmp(newnick, ls->user)) {
        nfree(ls->user);
        ls->user = nmalloc(strlen(newnick) + 1);
        strcpy(ls->user, newnick);
        found = 1;
        debug3("Transferred stats from %s to %s in %s", oldnick, newnick, gs->chan);
      }
    }
  }
  if (found)
    putlog(LOG_MISC, "*", "Stats.mod: Transferred stats from %s to %s", oldnick, newnick);
  Context;
  return 1;
}

static cmd_t stats_nkch[] =
{
  {"*", "", (Function) stats_checkhand, "stat:nkch"},
  {0, 0, 0, 0}
};

static void stats_autoadd(memberlist *m, char *chan)
{
  struct userrec *u;
  char s[121], s2[121], host[121];
  struct xtra_key *xk;
  time_t tt;

  Context;
  if (autoadd < 0)
    return;
  if (!m->nick[0])
    return;
  if ((now - m->joined) < (autoadd * 60))
    return;
  if (match_my_nick(m->nick))
    return;
  sprintf(s, "%s!%s", m->nick, m->userhost);
  if (strchr(s, '*') || strchr(s, '?'))
    return;     /* don't add users with wildcards in their hostmask */
  maskhost(s, host);
  u = get_user_by_host(s);
  if (u)
    return;
  u = get_user_by_handle(userlist, m->nick);
  if (u) {
    if (!matchattr(u, badflags, chan)) {
      addhost_by_handle(m->nick, host);
      putlog(LOG_MISC, "*", "Stats.mod: Added hostmask %s to %s.", host, m->nick);
      return;
    }
  } else {
    userlist = adduser(userlist, m->nick, host, "-", USER_DEFAULT);
    u = get_user_by_handle(userlist, m->nick);
    xk = nmalloc(sizeof(struct xtra_key));
    xk->key = nmalloc(7);
    strcpy(xk->key, "AADDED");
    xk->data = nmalloc(10);
    sprintf(xk->data, "%09lu", now);
    set_user(&USERENTRY_XTRA, u, xk);
    tt = now;
    strftime(s2, 120, "Added by Stats.mod on %d.%m.%Y %H:%M.", localtime(&tt));
    /* sprintf(s2, "Added by Stats.mod on %s", ctime(&tt)); */
    set_user(&USERENTRY_COMMENT, u, (void *) s2);
    set_handle_laston(chan, u, now);
    putlog(LOG_MISC, "*", "Stats.mod: Added %s to userlist.", m->nick);
  }
  Context;
}

static void deloldstatusers()
{
  struct laston_info *li;
  struct xtra_key *xk;
  struct userrec *u, *lu;
  int changed;

  if (stat_expire_user < 1)
    return;
  u = userlist;
  while (u) {
    changed = 0;
    li = get_user(&USERENTRY_LASTON, u);
    if (li) {
      if ((now - li->laston) > (stat_expire_user * 86400)) {
        for (xk = get_user(&USERENTRY_XTRA, u); xk; xk = xk->next) {
          if (!strcasecmp(xk->key, "AADDED")) {
            if(!get_user(&USERENTRY_PASS, u)) {
              putlog(LOG_MISC, "*", "Stats.mod: %s wasn't seen for over %d days. Deleted.", u->handle, stat_expire_user);
              lu = u->next;
              deluser(u->handle);
              u = lu;
              changed = 1;
              break;
            }
          }
        }
      }
    }
    if (!changed)
      u = u->next;
  }
}

static void purgestats()
{
  globstats *gs, *gs2;
  locstats *ls, *ls2;
  int i, kill;
  struct userrec *u2;
  struct chanset_t *chan;
  
  Context;
  gs = sdata;
  gs2 = NULL;
  while (gs) {
#ifndef OLDBOT
    chan = findchan_by_dname(gs->chan);
#else
    chan = findchan(gs->chan);
#endif
    if (chan && gs->local) {
      ls = gs->local;
      ls2 = NULL;
      while (ls) {
        kill = 1;
        u2 = get_user_by_handle(userlist, ls->user);
        if (u2) {
          for (i = 0; i < TOTAL_TYPES; i++) {
            if (ls->values[S_TOTAL][i] != 0) {
              kill = 0;
              break;
            }
          }
          if (!kill && strcmp(ls->user, u2->handle)) {
            debug2("Stats.mod: Transferred stats from %s to %s", ls->user, u2->handle);
            nfree(ls->user);
            ls->user = nmalloc(strlen(u2->handle) + 1);
            strcpy(ls->user, u2->handle);
          }
        }
        if (kill) {
          putlog(LOG_MISC, "*", "Stats.mod: Deleting stats for %s in %s(empty data or no such user)", ls->user, gs->chan);
          if (ls2)
            ls2->next = ls->next;
          else
            gs->local = ls->next;
          nfree(ls->user);
          nfree(ls);
          if (ls2)
            ls = ls2->next;
          else
            ls = gs->local;
        } else {
          ls2 = ls;
          ls = ls->next;
        }
      }
      gs2 = gs;
      gs = gs->next;
    } else {
      putlog(LOG_MISC, "*", "Stats.mod: Deleting stats for %s. (empty data or no such channel)", gs->chan);
      if (gs2)
        gs2->next = gs->next;
      else
        sdata = gs->next;
      free_localstats(gs->local);
      nfree(gs->chan);
      nfree(gs);
      if (gs2)
        gs = gs2->next;
      else
        gs = sdata;
    }
  }
  Context;
}
